unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  Dialogs, Menus, ComCtrls, ExtCtrls, ImgList, StdCtrls,
  ShellAPI, ShlObj;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    Open2: TMenuItem;
    Close1: TMenuItem;
    Exit1: TMenuItem;
    OpenDialog1: TOpenDialog;
    PopupMenu1: TPopupMenu;
    Extract2: TMenuItem;
    ImageList1: TImageList;
    N1: TMenuItem;
    About1: TMenuItem;
    About2: TMenuItem;
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    View1: TMenuItem;
    procedure Open2Click(Sender: TObject);
    procedure Extract2Click(Sender: TObject);
    procedure Extract1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure View1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure About2Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    procedure SaveToFile(Index: Integer;Tmp: Boolean);
    { Private declarations }
  public
    { Public declarations }
  end;

Type TLABHeader=record
  Descriptor:array [1..4] of char;//'LABN'
  X3:DWord;// 
  NumFiles:DWord;// 
  X4:DWord;// 
end;

Type TFileRecord=record
  X3:DWord;// 
  StartPos:DWord;// 
  Size:DWord;// 
  FType:array [1..4] of char;//   TEXT==TXET
  FileName:String[255];//
end;

var
  Form1: TForm1;
  Files:array [1..65535] of TFileRecord;
  FileCount:DWord;
  LABName,SaveToTarget:String;

implementation

uses extr, extrto, about;

{$R *.dfm}

procedure TForm1.Open2Click(Sender: TObject);
Var
  LABFile:TFileStream;
  H:TLABHeader;
  FInfo:TFileRecord;
  I:Integer;
  Tmp:String;
  Ch:Char;
  Fil:TListItem;
begin
  If OpenDialog1.Execute Then
  Begin
    LABName:=Opendialog1.FileName;
    LABFile:=TFileStream.Create(LABName,fmOpenRead,fmShareDenyNone);
    LABFile.Read(H,SizeOf(H));
    FileCount:=H.NumFiles;
    For i:=1 to FileCount do
    begin
      LABFile.Read(Files[i],SizeOf(H));
    end;
    i:=1;
    While (LABFile.Position<Files[1].StartPos)or(i<=FileCount) do
    begin
      LABFile.Read(Ch,1);
      If Ch<>#0 Then Tmp:=Tmp+Ch else
      begin
        Files[i].FileName:=Tmp;
        Inc(i);
        Tmp:='';
      end;
    end;
    Fil:=TListItem.Create(ListView1.Items);
    ListView1.AllocBy:=FileCount;
    For i:=1 to FileCount do
    begin
      Fil := ListView1.Items.Add;
      Fil.Caption := Files[i].FileName;
      If UpperCase(ExtractFileExt(Files[i].FileName))='.TXT' Then Fil.ImageIndex:=1 else
      If UpperCase(ExtractFileExt(Files[i].FileName))='.BMP' Then Fil.ImageIndex:=2 else
      If UpperCase(ExtractFileExt(Files[i].FileName))='.WAV' Then Fil.ImageIndex:=3 else Fil.ImageIndex:=0;
      Fil.SubItems.Add(IntToStr(Files[i].Size div 1024)+' Kb');
    End;
    StatusBar1.SimpleText:=IntToStr(FileCount)+' files total';
  End;
  LABFile.Free;
end;

Procedure TForm1.SaveToFile(Index:Integer;Tmp:Boolean);
Var
  F,LABFile:TFileStream;
  Buf:Pointer;
  i:Integer;
begin
  LabFile:=TFileStream.Create(LABName,fmOpenRead,fmShareDenyNone);
  LABFile.Seek(Files[Index].StartPos,soFromCurrent);
  If Not Tmp then
  Begin
    GetMem(Buf,Files[Index].Size);
    F:=TFileStream.Create(ExcludeTrailingPathDelimiter(SaveToTarget)+'\'+Files[Index].FileName,fmCreate,fmShareExclusive);
    LABFile.Read(Buf^,Files[Index].Size);
    F.Write(Buf^,Files[Index].Size);
    F.Free;
  end else
  begin
    GetMem(Buf,Files[Index].Size);
    F:=TFileStream.Create(ExcludeTrailingPathDelimiter(ExtractFileDir(Application.ExeName))+'\$tmp001$'+ExtractFileExt(Files[Index].FileName),fmCreate);
    LABFile.Read(Buf^,Files[Index].Size);
    F.Write(Buf^,Files[Index].Size);
    F.Free;
    ShellExecute(Form1.Handle,'open',PChar(ExtractFileDir(Application.ExeName)+'\$tmp001$'+ExtractFileExt(Files[Index].FileName)),'',PChar(ExtractFileDir(Application.ExeName)),SW_SHOWNORMAL);
  end;
  LABFile.Free;
end;

procedure TForm1.Extract2Click(Sender: TObject);
Var
  i:Integer;
begin
  ExtractProgress.Show;
  ExtractProgress.ProgressBar1.Position:=0;
  ExtractProgress.ProgressBar1.Max:=ListView1.Items.Count-1;
  For i:=0 to ListView1.Items.Count-1 do
  begin
    If ListView1.Items[i].Selected Then SaveToFile(i+1,False);
    Application.ProcessMessages;
    ExtractProgress.ProgressBar1.Position:=i;
    ExtractProgress.Label2.Caption:=IntToStr(i)+'\'+IntToStr(ListView1.Items.Count-1);
  end;
  ExtractProgress.Hide;
end;

procedure TForm1.Extract1Click(Sender: TObject);
begin
  SaveTo.Edit1.Text:=SaveToTarget;
  SaveTo.Show;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SaveToTarget:='C:\';
end;

procedure TForm1.ListView1DblClick(Sender: TObject);
begin
  SaveToFile(ListView1.ItemIndex+1,True);
end;

procedure TForm1.View1Click(Sender: TObject);
begin
  SaveToFile(ListView1.ItemIndex+1,True);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  TitleName : string;
  lpItemID : PItemIDList;
  BrowseInfo : TBrowseInfo;
  DisplayName : array[0..MAX_PATH] of char;
  TempPath : array[0..MAX_PATH] of char;
begin
  FillChar(BrowseInfo, sizeof(TBrowseInfo),#0);
  BrowseInfo.hwndOwner := Form1.Handle;
  BrowseInfo.pszDisplayName:=@DisplayName;
  TitleName := 'Please specify a directory';
  BrowseInfo.lpszTitle := PChar(TitleName);
  BrowseInfo.ulFlags := BIF_RETURNONLYFSDIRS;
  lpItemID := SHBrowseForFolder(BrowseInfo);
  if lpItemId <> nil then
  begin
    SHGetPathFromIDList(lpItemID, TempPath);
    Edit1.Text:=TempPath;
    SaveToTarget:=TempPath;
    GlobalFreePtr(lpItemID);
  end;
end;

procedure TForm1.About2Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  ListView1.Clear;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Application.Terminate;
end;

end.
